#include "rca.h"

#define echoPin 5 // Echo Pin(gZT[?)
#define trigPin 6 // Trigger Pin(gZT[?)


#define TOUCH_PIN 3
#define LED_PIN  4


double Distance = 0; //QƂ̋(cm)
double Threshold_1 = 30; //ʒm臒l(cm)
double Threshold_2 = 80; //ʒm臒l(cm)

int LEDstate = LOW; //LED_łƂɎg.
bool alert = false; //ʒmpLϐ.task2,task3ǂݍ.

int SoundState = 0;
/*
 *  C^XN̐ݒ.
 *  fobOo͂Ȃ,VA|[g115200ɂĂ.
 */ 
void setup() {
    Serial.begin(115200);//fobOo͂ȂȂRgAEgł낵
    delay(1);        
}

//C^XN
void loop() {
    delay(1000);
}

/*
 *  ^XN1̐ݒ.
 *  gZT[̏s.
 */
void task1_setup() {
	pinMode(echoPin, INPUT);
	pinMode(trigPin, OUTPUT);
}

/*
 *  ^XN1.
 *  gZT[ɂ鑪s.
 *  ̌ʂcmPʂDistanceϐɊi[.
 */
void task1_loop() {
	//瑪{
	double Duration = 0; //gMԊu
	digitalWrite(trigPin, LOW);
	delayMicroseconds(2);
	digitalWrite(trigPin, HIGH); //go
	delayMicroseconds(10);
	digitalWrite(trigPin, LOW);
	Duration = pulseIn(echoPin, HIGH); //ZT̓
	//܂ő{
	//DistanceZo
	if (Duration > 0) {
		Duration = Duration / 2; //𔼕ɂ
		Distance = Duration * 340 * 100 / 1000000; // 340m/sɐݒ
		//Serial.println(Distance); //fobOo͂ItɂȂsv.
	}
	//܂DistanceZo
	delay(10);
}


int tonewaiter1 = 0;
int tonewaiter2 = 0;
void task2_setup() {}
void task2_loop() {
	if (SoundState != 0) {
		if (Threshold_1 >= Distance) {
			tonewaiter2 = 0;
			if (tonewaiter1 == 25) {
				tone(12, 4000, 50);
				tonewaiter1 = 0;
			}
			tonewaiter1++;
		}
		else if (Threshold_2 >= Distance) {
			tonewaiter1 = 0;
			if (tonewaiter2 == 50) {
				tone(12, 4000, 50);
				tonewaiter2 = 0;
			}tonewaiter2++;

		}
	}
	
	delay(10);
}

int PreTouchValue = 0;
int TouchState = 0;


void task3_setup() {
	
	pinMode(TOUCH_PIN, INPUT_PULLUP);
	pinMode(LED_PIN, OUTPUT);
	digitalWrite(LED_PIN, LOW);
	
}  
void task3_loop() {
	int TouchValue = digitalRead(TOUCH_PIN);

	if ((PreTouchValue == 0) && (TouchValue == 1) && (TouchState = 0)) {
		TouchState = 1;
	}

	if ((PreTouchValue == 1) && (TouchValue == 0) && (TouchState = 1)) {
		TouchState = 0;
		if (SoundState == 0) {
			SoundState = 1;
			Threshold_1 = 30; //߂ق̒ʒm臒l30(cm)ɐݒ
			digitalWrite(LED_PIN, HIGH);
			tone(12, 4000, 50);
			delay(30);
			tone(12, 4000, 50);
			digitalWrite(LED_PIN, LOW);
		}
		else if(SoundState == 1) {
			SoundState = 2;
			Threshold_1 = 50; //߂ق̒ʒm臒l50(cm)ɐݒ
			digitalWrite(LED_PIN, HIGH);
			tone(12, 6000, 100);
			delay(30);
			digitalWrite(LED_PIN, LOW);
		}
		else {
			SoundState = 0;
			digitalWrite(LED_PIN, HIGH);
			tone(12, 4000, 200);
			delay(20);
			digitalWrite(LED_PIN, LOW);
		}
	}
	PreTouchValue = TouchValue;
	
	delay(10);
}
	

